#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "Vector.h"
#include "adtbinarytree.h"

typedef int LIB_STORAGE;
typedef int REQ_BOOK_STORAGE;
LIB_STORAGE s;
REQ_BOOK_STORAGE rs;
s=34;
rs=22;
int checkFound;
int FreeTimeCounter=0, EfficientTimeCounter=0, InefficientTimeCounter=0, TotalInefficientTime=0, TotalEfficientTime=0, TotalTreeSteps=0;
int which=0;
//int TreeStepsCounter=0;
int MissingFeature[26];

void main()
{
  //Tree

    Tree *tree = NULL;
    int error=0;
    tree = createTree(tree, &error);

    //Vector
  Vector *v=NULL;
  CreateVector(&v);

  int random;
  srand (time(NULL));


  int a, b;
  int i, q=0;
  int* LibraryBooks;
  int* RequiredBooks;
  int* RequiredBookNumbers;
  int number=19, RQ=-1;
  int LetterNumber = 2;
  int* LetterPlace;
  LibraryBooks=(int*)malloc (s*sizeof(int));
  RequiredBooks=(int*)malloc (rs*sizeof(int));
  RequiredBookNumbers=(int*)malloc(rs*sizeof(int));
  LetterPlace=(int*)malloc (26*sizeof(int));
  int totalBooks = 1;
  int size=0;
  int LetterChecker, LetterCounter=0;
  int TreeStepsCounter=0;
  int*ptr=&TreeStepsCounter;


  FILE* Lib = fopen ("LibraryBookList.txt", "r");
  FILE* Req = fopen("RequiredBooks.txt", "r");



  fscanf (Lib, "%d", &a);
  LetterChecker=a;
  fscanf (Lib, "%d", &b);
  LibraryBooks[totalBooks-1]=b;
  LetterPlace[a]=totalBooks-1;
  int lol=0, counter=0;
  while (!feof (Lib))
    {
      if (LetterChecker!=a)
      {
        LetterPlace[a]=(totalBooks-1);
        LetterChecker=a;
        MissingFeature[lol]=counter;
        lol++;
        counter=0;
      }
      counter++;
      totalBooks++;
      AddElement(v, b);
      insert(tree, b);
      fscanf (Lib, "%d", &a);
      fscanf (Lib, "%d", &b);
      LibraryBooks[totalBooks-1]=b;

    }
    MissingFeature[lol]=counter;
    lol++;
    balance(&(tree->root));

    while(!feof(Req))
    {
      fscanf(Req, "%d", &a);
      fscanf(Req, "%d", &b);
      RequiredBookNumbers[q]=a;
      RequiredBooks[q]=b;
      q++;
    }
  fclose (Lib);
  fclose (Req);

  while((q)>0)
  {
    random = rand()%1000;
    if(random>900)
    {
        findBook(q, RequiredBooks, RequiredBookNumbers, totalBooks, &v, LetterPlace, LibraryBooks, ptr);
        getElementByValue(tree->root, RequiredBooks[RequiredBookNumbers[which]], ptr);
        q--;
        which++;
    }
    FreeTimeCounter++;
  }
}



  int simpleSearch(int* LibraryBooks, int number, int totalBooks)
  {
    int i, a;
    for(i=0; i<totalBooks-1; i++)
    {
        if(LibraryBooks[i]==number)
        {
          a=1;
          i=totalBooks;
        }
      InefficientTimeCounter++;
    }
    if (a==1) return 1;
    else return 0;
  }
  int vectorSearch(int **v, int number, int* LetterPlace, int* RequiredBookNumbers, int totalBooks, int* RequiredBooks)
  {
    int BookNumber, i, check=0;
    for(i=LetterPlace[RequiredBookNumbers[which]]; i<LetterPlace[RequiredBookNumbers[which]]+5; i++)
    {
      BookNumber=GetElementValue(v, i);
      if(BookNumber==number)
      {
      check=1;
      i=totalBooks;
      }
      EfficientTimeCounter++;
    }
    if (check==1) return 1;
    else return 0;
  }
  int findBook(int q, int*RequiredBooks, int* RequiredBookNumbers, int totalBooks, int**v, int*LetterPlace, int* LibraryBooks, int*ptr)
  {
    int a;
    a=RequiredBooks[which];
    checkFound=vectorSearch(v, a, LetterPlace, RequiredBookNumbers, totalBooks, RequiredBooks);
    simpleSearch(LibraryBooks, a, totalBooks);
    printf("Time passed until reader arrived: %d\n", FreeTimeCounter);
    printf("If library books were not in order, reader would have to wait: %d\n", InefficientTimeCounter);
    printf("If library books were in order, reader would have to wait: %d\n", EfficientTimeCounter);
    printf("If library books were in binary tree, reader would have to wait: %d\n", *ptr);
    if(checkFound==1) printf("Reader's book was found\n\n");
    else printf("Reader's book was not found\n\n");
    TotalTreeSteps+=FreeTimeCounter+(*ptr);
    TotalEfficientTime+=FreeTimeCounter+EfficientTimeCounter;
    TotalInefficientTime+=FreeTimeCounter+InefficientTimeCounter;
    (*ptr)=0;
    InefficientTimeCounter=0;
    EfficientTimeCounter=0;
    FreeTimeCounter=0;
  }
